/*
    Copyright 1983 Computer Development Inc Beaverton Or USA
	      All commercial rights reserved
*/

#include <stdio.h>

#define OK      0
#define ERROR   -1
 
main(int argc,char **argv)
{
	int errors = 0;
	while(--argc>0)
		errors|=crc_file(*++argv);
	exit(errors!=0);
}
 
 
/* update CRC */
unsigned short int update_crc(int c,unsigned short int crc)
{
	int count;
 
	for(count=8;--count>=0;) {
		if(crc&0x8000) {
			crc<<=1;
			crc+=(((c<<=1)&0400)!=0);
			crc^=0x1021;
		}
		else {
			crc<<=1;
			crc+=(((c<<=1)&0400)!=0);
		}
	}
	return crc;
}
 
crc_file(char *name)
{
	FILE *input;
	unsigned short int crc=0;
	int byte;
	long int byte_count=0;
 
	if ((input=fopen(name,"rb"))==NULL)
		return ERROR;

	while ((byte=getc(input))!=EOF) {
		++byte_count;
		crc=update_crc(byte,crc);
	}
	crc=update_crc(0,update_crc(0,crc));
	fclose(input);
 
	printf("File->%-2s\tBytes->%7ld\tCRC->%04X\n",name,byte_count,crc);

}
